OGRE: Ogre::GL3PlusBufferInterface Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Member Functions | List of all members
Ogre::GL3PlusBufferInterface Class Reference

For GL3+, most (if not all) buffers, can be treated with the same code. More...

`#include <OgreGL3PlusBufferInterface.h>`

Inheritance diagram for Ogre::GL3PlusBufferInterface:
[legend]

## Public Member Functions
| GL3PlusBufferInterface (size_t vboPoolIdx, GLuint vboName, GL3PlusDynamicBuffer *dynamicBuffer)
| ~GL3PlusBufferInterface ()
virtual void | _ensureDelayedImmutableBuffersAreReady (void)
void | _firstUpload (void *data, size_t elementStart, size_t elementCount)
| Only use this function for the first upload. More...
virtual void | _notifyBuffer (BufferPacked *buffer)
void | _setVboPoolIndex (size_t newVboPool)
virtual void | advanceFrame (void)
virtual void | copyTo (BufferInterface *dstBuffer, size_t dstOffsetBytes, size_t srcOffsetBytes, size_t sizeBytes)
BufferPacked * | getBufferPacked (void)
GLuint | getVboName (void) const
size_t | getVboPoolIndex (void)
virtual void *RESTRICT_ALIAS_RETURN | map (size_t elementStart, size_t elementCount, MappingState prevMappingState, bool advanceFrame=true)
virtual void | regressFrame (void)
virtual void | unmap (UnmapOptions unmapOption, size_t flushStartElem=0, size_t flushSizeElem=0)
void | upload (const void *data, size_t elementStart, size_t elementCount)

## Detailed Description

For GL3+, most (if not all) buffers, can be treated with the same code.

Hence most equivalent functionality is encapsulated here.

## Constructor & Destructor Documentation

## ◆ GL3PlusBufferInterface()

Ogre::GL3PlusBufferInterface::GL3PlusBufferInterface | ( | size_t | vboPoolIdx,
|  | GLuint | vboName,
|  | GL3PlusDynamicBuffer * | dynamicBuffer
| ) |  |

## ◆ ~GL3PlusBufferInterface()

Ogre::GL3PlusBufferInterface::~GL3PlusBufferInterface | ( |  | ) |

## Member Function Documentation

## ◆ _ensureDelayedImmutableBuffersAreReady()

virtual void Ogre::BufferInterface::_ensureDelayedImmutableBuffersAreReady | ( | void |  | ) |
| virtualinherited

Reimplemented in Ogre::D3D11BufferInterfaceBase.

## ◆ _firstUpload()

void Ogre::GL3PlusBufferInterface::_firstUpload | ( | void * | data,
|  | size_t | elementStart,
|  | size_t | elementCount
| ) |  |

Only use this function for the first upload.

## ◆ _notifyBuffer()

virtual void Ogre::BufferInterface::_notifyBuffer | ( | BufferPacked * | buffer | ) |
| inlinevirtualinherited

Reimplemented in Ogre::NULLBufferInterface.

## ◆ _setVboPoolIndex()

void Ogre::GL3PlusBufferInterface::_setVboPoolIndex | ( | size_t | newVboPool | ) |
| inline

## ◆ advanceFrame()

virtual void Ogre::GL3PlusBufferInterface::advanceFrame | ( | void |  | ) |
| virtual

Implements Ogre::BufferInterface.

## ◆ copyTo()

virtual void Ogre::GL3PlusBufferInterface::copyTo | ( | BufferInterface * | dstBuffer,
|  | size_t | dstOffsetBytes,
|  | size_t | srcOffsetBytes,
|  | size_t | sizeBytes
| ) |  |
| virtual

Implements Ogre::BufferInterface.

## ◆ getBufferPacked()

BufferPacked* Ogre::BufferInterface::getBufferPacked | ( | void |  | ) |
| inlineinherited

## ◆ getVboName()

GLuint Ogre::GL3PlusBufferInterface::getVboName | ( | void |  | ) | const
| inline

## ◆ getVboPoolIndex()

size_t Ogre::GL3PlusBufferInterface::getVboPoolIndex | ( | void |  | ) |
| inline

## ◆ map()

virtual void* RESTRICT_ALIAS_RETURN Ogre::GL3PlusBufferInterface::map | ( | size_t | elementStart,
|  | size_t | elementCount,
|  | MappingState | prevMappingState,
|  | bool | advanceFrame = `true`
| ) |  |
| virtual

Implements Ogre::BufferInterface.

## ◆ regressFrame()

virtual void Ogre::GL3PlusBufferInterface::regressFrame | ( | void |  | ) |
| virtual

Implements Ogre::BufferInterface.

## ◆ unmap()

virtual void Ogre::GL3PlusBufferInterface::unmap | ( | UnmapOptions | unmapOption,
|  | size_t | flushStartElem = `0`,
|  | size_t | flushSizeElem = `0`
| ) |  |
| virtual

Implements Ogre::BufferInterface.

## ◆ upload()

void Ogre::BufferInterface::upload | ( | const void * | data,
|  | size_t | elementStart,
|  | size_t | elementCount
| ) |  |
| inherited

The documentation for this class was generated from the following file:

- OgreGL3PlusBufferInterface.h